/**********************************************************************
 *
 *       *** HAPPy P-code Interpriter ***
 *
 *          Standard procedure , function ̏
 *
 *        void callsp(void)
 *        void T_get(int fileno, _store *filebuf, FILE *fp,char *name)
 *
 *            Copyright (c) H.Asano 1992.
 **********************************************************************/

#define EXTERN extern

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "hapai.h"

extern void prerr(int,char*) ;

/********* P-CODE COMPUTER store **********/
extern _store store[] ;

/********* P-CODE COMPUTER registers **********/

extern int q   ;      /* q */

extern _store *sp ;  /* sp points to top of the stack */

extern int pc   ;     /* program counter */
extern int mp   ;     /* mp points to begginning of a data segment */
extern int ep   ;     /* ep points to the maxmum extent of the stack */
extern int np   ;     /* np points to top of the dynamically allocated area */


extern boolean readlnflag ;             /* inputreadln y
                                           Nɂ͐^               */


/**************************************************/
/* searchfile() : fileadrɑΉt@CT *
/**************************************************/
static fileinfo *searchfile(int fileadr)
{
  int i = -1 ;

     while(fi[++i].fileadr != fileadr) ;
     return(fi+i) ;
}

/**************************************************/
/* fileerrmsg() : file֌W̃G[bZ[Wo  */
/**************************************************/
static void fileerrmsg(int msgno,char *pname,fileinfo *fiadr,char *msg)
{
  char *fname, *rfname;
  char buf[160] ;

     fname =  (*fiadr).filename ;
     rfname = (*fiadr).rfname   ;
     sprintf(buf,"%s: %s(t@C=%s)%s", pname,fname,rfname,msg) ;
     prerr(msgno,buf) ;
}

/******************************************/
/* checkgeneration() : [h`FbN */
/******************************************/
static void checkgeneration(char *pname,fileinfo *fiadr)
{
     if((*fiadr).mode != generation)
      fileerrmsg(9,pname,fiadr,"[hłȂ") ;
}

/******************************************/
/* checkinspection() : [h`FbN */
/******************************************/
static void checkinspection(char *pname,fileinfo *fiadr)
{
     if((*fiadr).mode != inspection)
      fileerrmsg(14,pname,fiadr,"[hłȂ") ;
}

/*************************************************/
/* err131() : t@CݏQbZ[Wo */
/*************************************************/
static void err131(char *pname,fileinfo *fiadr)
{
      fileerrmsg(131,pname,fiadr,"ŏQ") ;
}

/*****************************************/
/* T_get() : textt@C1Ǎ */
/*****************************************/
void T_get(fileinfo *fiadr, _store *filebuf, FILE *fp,char *name)
{
     if(feof((*fiadr).fp))
      fileerrmsg(42,name,fiadr,"EOFƂȂĂ") ;

     (*filebuf).vc = getc(fp) ;         /* 1ǂ                */

     if(ferror(fp))
      fileerrmsg(181,name,fiadr,"ŏQ") ;

     (*fiadr).eolnflag = (*filebuf).vc == '\n' ;
                                        /* sǂ񂾎 ^          */
     if((*fiadr).eolnflag) (*filebuf).vc = ' ' ;
}

/******************* eP-codȅ ***********************************/

/**************************************/
/* ATN() : arctanW֐             */
/**************************************/
static void ATN(void)
{
     (*sp).vr = (float)atan((double)(*sp).vr);
}

/**************************************/
/* COS() : cosW֐                */
/**************************************/
static void COS(void)
{
     (*sp).vr = (float)cos((double)(*sp).vr) ;
}

/**************************************/
/* DIS() : disposeW葱          */
/**************************************/
static void DIS(void)
{
  int ad ;

     ad = (*(sp-1)).va ;                /* AhX           */
     if(ad == NilValue)
      prerr(23,"dispose: ̒lnilł") ;
     if((np <= ad) && (ad < Maxstore)) {            /* l         */
      if(ad == np) np += (short)(*sp).vi ;    /* Ԍnew*/
                                              /* {ɉ       */
     }
     else prerr(24,"dispose: ̒lsł") ;
     sp-=2 ;
}

/***************************************/
/* EOL() : eolW֐                 */
/***************************************/
static void EOL(void)
{
  fileinfo *fiadr ;

     fiadr  = searchfile((*sp).va) ;

     if((*fiadr).mode == undefined)
      fileerrmsg(41,"eoln",fiadr,"sł") ;

     if(feof((*fiadr).fp))
      fileerrmsg(42,"eoln",fiadr,"EOFƂȂĂ") ;

     if((fiadr==fi) && readlnflag) {    /* inputt@CŒOreadln*/
      T_get(fiadr,store+(*sp).va,(*fiadr).fp,"eoln") ;
                                        /* ̕Ǎ             */
      readlnflag = false ;
     }
     (*sp).vb = (*fiadr).eolnflag ;
}

/***************************************/
/* EoF() : eofW֐                 */
/***************************************/
static void EoF(void)
{
  int fileadr ;
  fileinfo *fiadr ;

     fileadr = (*sp).va ;
     fiadr   = searchfile(fileadr) ;
     if((fiadr==fi) && readlnflag) {    /* inputt@CŒOreadln*/
      T_get(fiadr,store+fileadr,(*fiadr).fp,"eof") ;
                                        /* ̕Ǎ             */
      readlnflag = false ;
      (*sp).vb = feof((*fiadr).fp) ;
     }
     else {                             /* ʏeof                  */
      if((*fiadr).mode == undefined)
       fileerrmsg(40,"eof",fiadr,"sł") ;

      (*sp).vb = ((*fiadr).mode == generation) /* [h͐^*/
                     ?  true : feof((*fiadr).fp) ;
     }
}

/**************************************/
/* EXP() : expW֐                */
/**************************************/
static void EXP(void)
{
     (*sp).vr = (float)exp((double)(*sp).vr) ;
}

/**************************************/
/* GET() : eLXgt@CȊOget  */
/**************************************/
static void GET(void)
{
  int fileadr ;
  fileinfo *fiadr ;
  FILE *fp    ;

     fileadr = (*sp--).va ;
     fiadr   = searchfile(fileadr) ;
     fp      = (*fiadr).fp ;

     checkinspection("get",fiadr) ;

     if(feof(fp))
      fileerrmsg(16,"get",fiadr,"EOFƂȂĂ") ;

     fread(store+fileadr, (*fiadr).filesize*sizeof(_store),1,fp);

     if(ferror(fp)) err131("get",fiadr) ;
}

/**************************************/
/* LOG() : lnW֐                 */
/**************************************/
static void LOG(void)
{
     if((*sp).vr <= (float)0.0)
      prerr(33,"ln: ̒l0ȉł") ;
     (*sp).vr = (float)log((double)(*sp).vr);
}

/**************************************/
/* NEW() : newW葱              */
/**************************************/
static void NEW(void)
{
  int ad ;

     ad = np-(short)(*sp).vi ;
     if(ad <= ep)
       prerr(121,"new: sŊtłȂ") ;
     np = ad ;
     ad = (*(sp-1)).va ;
     store[ad].va = np ;
     sp-=2 ;
}

/**************************************/
/* PGE() : pageW葱             */
/**************************************/
static void PGE(void)
{
  fileinfo *fiadr ;

     fiadr = searchfile((*sp--).va) ;
     checkgeneration("page",fiadr) ;

     if(!(*fiadr).writelnflag)        /* ŌオsłȂ         */
      if(fputc('\n',(*fiadr).fp) == EOF) err131("page",fiadr) ;
     if(fputc('\f',(*fiadr).fp) == EOF)  err131("page",fiadr) ;
     (*fiadr).writelnflag = false ;
}

/**************************************/
/* PUT() : eLXgt@CȊOput  */
/**************************************/
static void PUT(void)
{
  int  fileadr ;
  fileinfo *fiadr ;
  FILE *fp     ;

     fileadr = (*sp--).va ;
     fiadr   = searchfile(fileadr) ;
     fp      = (*fiadr).fp  ;

     checkgeneration("put",fiadr) ;

     fwrite(store+fileadr, (*fiadr).filesize*sizeof(_store),1,fp) ;

     if(ferror(fp))
      fileerrmsg(182,"put",fiadr,"ŏQ") ;
}

/**************************************/
/* RLN() : eLXgt@Creadln   */
/**************************************/
static void RLN(void)
{
  FILE   *fp      ;
  _store *filebuf ;
  fileinfo *fiadr ;

     fiadr   = searchfile((*sp).va) ;
     fp      = (*fiadr).fp            ;
     filebuf = (*fiadr).filebuf       ;

     checkinspection("read",fiadr) ;

     if((fiadr==fi) && readlnflag)
      T_get(fiadr,filebuf,fp,"readln");

     while(!(*fiadr).eolnflag)
      T_get(fiadr,filebuf,fp,"readln");  /* sǂݔ΂     */
     if(fiadr == fi) readlnflag = true ; /* inputt@C̎        */
     else
      T_get(fiadr,filebuf,fp,"readln") ; /* ̕Ǎ           */

     sp-- ;
}

/*****************************************/
/* RDC() : eLXgt@C̕Ǎ*/
/*****************************************/
static void RDC(void)
{
  FILE   *fp      ;
  _store *filebuf ;
  fileinfo *fiadr ;
  short ad ;

     fiadr   = searchfile((*sp).va) ;
     fp      = (*fiadr).fp            ;
     filebuf = (*fiadr).filebuf       ;

     checkinspection("read",fiadr) ;

     if(feof(fp))
      fileerrmsg(16,"read",fiadr,"EOFƂȂĂ") ;

     if((fiadr==fi) && readlnflag) {   /* inputt@CŒOreadln*/
      T_get(fiadr,filebuf,fp,"read") ; /* ̕Ǎ             */
      readlnflag = false ;
     }

     ad = (*(sp-1)).va ;
     store[ad].vc = (*filebuf).vc  ;    /* obt@ϐϐ֑ */

     T_get(fiadr,filebuf,fp,"read") ;  /* ̕Ǎ             */

     sp-=2               ;
}

/*****************************************/
/* RDI() : eLXgt@C̐Ǎ*/
/*****************************************/
static void RDI(void)
{
  FILE   *fp      ;
  _store *filebuf ;
  fileinfo *fiadr ;
  int  ad  ;
  int  lch ;
  integer  ival = 0 ;
  int sign = 1 ;

     fiadr   = searchfile((*sp).va) ;
     fp      = (*fiadr).fp            ;
     filebuf = (*fiadr).filebuf       ;
     ad = (*(sp-1)).va;

     checkinspection("read",fiadr) ;

     if((fiadr==fi) && readlnflag) {   /* inputt@CŒOreadln*/
      T_get(fiadr,filebuf,fp,"read") ; /* ̕Ǎ             */
      readlnflag = false ;
     }

     while((*filebuf).vc == ' ')        /* 󔒓ǂݔ΂             */
      T_get(fiadr,filebuf,fp,"read");
     if(((*filebuf).vc=='+') || ((*filebuf).vc=='-')) { /* ̎   */
      sign = ((*filebuf).vc=='+') ? 1 : -1  ; /* ɉ     */
      T_get(fiadr,filebuf,fp,"read");
     }

     if(((*filebuf).vc >= '0') && ((*filebuf).vc <= '9')) { /*    */
      do {
       lch = (*filebuf).vc - '0' ;
       if(ival <= (Maxint-lch/10))      /* `FbN               */
        ival = ival*10 + lch ;
       else
        fileerrmsg(54,"read",fiadr,
                   "畄ť`łȂ̂ǂƂ") ;
       T_get(fiadr,filebuf,fp,"read");
       if(feof(fp)) break ;             /* eofI          */
      } while(('0' <= (*filebuf).vc ) && ((*filebuf).vc <= '9')) ;

      store[ad].vi = sign * ival ;
     }
     else {                             /* ŏɐȂ   */
      if(feof(fp)) fileerrmsg(16,"read",fiadr,"EOFƂȂĂ") ;
      fileerrmsg(54,"read",fiadr,
                 "畄ť`łȂ̂ǂƂ") ;
     }

     sp-=2;
}

/*****************************************/
/* RDR() : eLXgt@C̎Ǎ*/
/*****************************************/
static void RDR(void)
{
  FILE   *fp      ;
  _store *filebuf ;
  fileinfo *fiadr ;
  char buf[80] ;
  char *stopstring ;
  int  i       ;
  integer ival = 0 ;                    /* ̒l                 */

     fiadr   = searchfile((*sp).va) ;
     fp      = (*fiadr).fp            ;
     filebuf = (*fiadr).filebuf       ;

     checkinspection("read",fiadr) ;

     if((fiadr==fi) && readlnflag) {   /* inputt@CŒOreadln*/
      T_get(fiadr,filebuf,fp,"read") ; /* ̕Ǎ             */
      readlnflag = false ;
     }

     for(i=0;i<80;i++) *(buf+i) = '\0'; /* obt@NA             */
     i = 0 ;

     while((*filebuf).vc == ' ')        /* 󔒓ǂݔ΂             */
      T_get(fiadr,filebuf,fp,"read");
     if(((*filebuf).vc=='+') || ((*filebuf).vc=='-')) { /* ̎   */
      buf[i++] = (char)(*filebuf).vc ;
      T_get(fiadr,filebuf,fp,"read");
     }

     if(((*filebuf).vc >= '0') && ((*filebuf).vc <= '9')) { /*    */
      do {
       buf[i++] = (char)(*filebuf).vc ;
       ival = ival*10 + (*filebuf).vc - '0';
       T_get(fiadr,filebuf,fp,"read");
       if(feof(fp)) break ;             /* eofI          */
      } while(('0' <= (*filebuf).vc ) && ((*filebuf).vc <= '9')) ;

      if((*filebuf).vc == '.') {         /* _                     */
       buf[i++] = (char)(*filebuf).vc ;
       T_get(fiadr,filebuf,fp,"read");  /* _ǂݔ΂         */
       if(((*filebuf).vc >= '0') && ((*filebuf).vc <= '9')) { /*   */
        do {
         buf[i++] = (char)(*filebuf).vc ;
         T_get(fiadr,filebuf,fp,"read");
         if(feof(fp)) break ;           /* eofI          */
        } while(('0' <= (*filebuf).vc ) && ((*filebuf).vc <= '9')) ;
       }
       else goto error ;                /* . ̎łȂ       */
      }

      if(((*filebuf).vc == 'e') || ((*filebuf).vc == 'E')) { /* w*/
       buf[i++] = (char)(*filebuf).vc ;
       T_get(fiadr,filebuf,fp,"read");  /* e܂Eǂݔ΂    */
       if(((*filebuf).vc=='+') || ((*filebuf).vc=='-')) { /* ̎*/
        buf[i++] = (char)(*filebuf).vc ;
        T_get(fiadr,filebuf,fp,"read");
       }
       if(((*filebuf).vc >= '0') && ((*filebuf).vc <= '9')) { /* */
        do {
         buf[i++] = (char)(*filebuf).vc ;
         T_get(fiadr,filebuf,fp,"read");
         if(feof(fp)) break ;           /* eofI          */
        } while(('0' <= (*filebuf).vc ) && ((*filebuf).vc <= '9')) ;
       }
       else goto error ;                /* w̍ŏłȂ   */
      }
     }
     else goto error ;                  /* ŏɐȂ   */

     store[(*(sp-1)).va].vr = (float)strtod(buf,&stopstring) ;

     sp -= 2;
     return ;

 error :                                /* łȂ       */
     if(feof(fp)) fileerrmsg(16,"read",fiadr,"EOFƂȂĂ") ;
     fileerrmsg(56,"read",fiadr,
                "畄ť`łȂ̂ǂƂ") ;
}

/****************************************/
/* RST() : eLXgt@CȊOreset  */
/****************************************/
static void RST(void)
{
   int  fileadr ;
   fileinfo *fiadr ;
   FILE *fp     ;

     fileadr = (*sp--).va ;
     fiadr   = searchfile(fileadr) ;

     fclose((*fiadr).fp) ;            /*܂N[Y(G[łǂ)*/
     fp = fopen((*fiadr).rfname,"rb") ;
     if(fp == NULL)
      fileerrmsg(13,"reset",fiadr,"sł") ;

     (*fiadr).mode = inspection ;     /* [h                 */
     (*fiadr).fp   = fp ;
     fread(store+fileadr, (*fiadr).filesize*sizeof(_store),1,fp) ;
                                        /* ŏ̗vfobt@ϐ */
}

/******************************************/
/* RWT() : eLXgt@CȊOrewrite  */
/******************************************/
static void RWT(void)
{
  fileinfo *fiadr ;

     fiadr  = searchfile((*sp--).va) ;

     fclose((*fiadr).fp) ;            /*܂N[Y(G[łǂ)*/
     (*fiadr).fp = fopen((*fiadr).rfname,"wb") ;
     if((*fiadr).fp == NULL)
      fileerrmsg(132,"rewrite",fiadr,"̃I[vłȂ") ;

     (*fiadr).mode = generation ;     /* [h                 */
}

/***************************************/
/* SIN() : sinW֐                 */
/***************************************/
static void SIN(void)
{
     (*sp).vr = (float)sin((double)(*sp).vr) ;
}

/***************************************/
/* SQT() : sqrtW֐                */
/***************************************/
static void SQT(void)
{
     if((*sp).vr < (float)0.0)      /* ̕                 */
      prerr(34,"sqrt:̒lł") ;
     (*sp).vr = (float)sqrt((double)(*sp).vr);
}

/***************************************/
/* TGT() : eLXgt@Cget       */
/***************************************/
static void TGT(void)
{
  FILE   *fp      ;
  _store *filebuf ;
  fileinfo *fiadr ;

     fiadr   = searchfile((*sp).va) ;
     fp      = (*fiadr).fp            ;
     filebuf = (*fiadr).filebuf       ;

     checkinspection("get",fiadr) ;

     if((fiadr==fi) && readlnflag) {   /* inputt@CŒOreadln*/
      T_get(fiadr,filebuf,fp,"get") ;  /* ̕Ǎ             */
      readlnflag = false ;
     }

     if(feof(fp))
      fileerrmsg(16,"get",fiadr,"EOFƂȂĂ") ;

     T_get(fiadr,filebuf,fp,"get") ;   /* ̕Ǎ             */

     sp-- ;
}

/***************************************/
/* TPT() : eLXgt@Cւput     */
/***************************************/
static void TPT(void)
{
  FILE *fp    ;
  fileinfo *fiadr ;

     fiadr   = searchfile((*sp).va) ;
     fp      = (*fiadr).fp            ;
     checkgeneration("put",fiadr) ;

     if(fputc((*(store+(*sp--).va)).vc,fp) == EOF)   /* o  */
      err131("put",fiadr) ;
     (*fiadr).writelnflag = false ;
}

/***************************************/
/* TRS() : eLXgt@Cւreset   */
/***************************************/
static void TRS(void)
{
  FILE *fp ;
  fileinfo *fiadr ;
  _store *filebuf ;

     fiadr   = searchfile((*sp--).va) ;
     filebuf = (*fiadr).filebuf         ;

     if((strcmp((*fiadr).filename,"input")==0) || /* inputt@C  */
        (strcmp((*fiadr).filename,"output")==0))  /* outputt@C */
      fileerrmsg(81,"reset",fiadr,"ɑ΂reset͂łȂ") ;

     if((*fiadr).mode == generation)  /* [h̎         */
      if(! (*fiadr).writelnflag)      /* Ōオs}[NłȂ   */
       if(fputc('\n',(*fiadr).fp) == EOF)  /* s        */
        err131("reset",fiadr) ;
     fclose((*fiadr).fp) ;            /* t@CN[Y           */
     fp = fopen((*fiadr).rfname,"rt") ; /* eLXg[hI[v   */
     if(fp == NULL)
      fileerrmsg(13,"reset",fiadr,"sł") ;
     (*fiadr).fp   = fp ;
     (*fiadr).mode = inspection ;     /* [h                 */
     (*fiadr).textfile = true   ;     /* eLXgt@C           */

     T_get(fiadr,filebuf,fp,"reset") ; /* ŏ̕ǂ           */
}

/***************************************/
/* TRW() : eLXgt@Cւrewrite */
/***************************************/
static void TRW(void)
{
  fileinfo *fiadr ;

     fiadr  = searchfile((*sp--).va) ;

     if((strcmp((*fiadr).filename,"input")==0) || /* inputt@C  */
        (strcmp((*fiadr).filename,"output")==0))  /* outputt@C */
      fileerrmsg(82,"rewrite",fiadr,"ɑ΂rewrite͂łȂ") ;

     fclose((*fiadr).fp) ;            /*܂N[Y(G[łǂ)*/
     (*fiadr).fp = fopen((*fiadr).rfname,"wt") ;
     if((*fiadr).fp == NULL)
      fileerrmsg(132,"rewrite",fiadr,"̃I[vłȂ") ;

     (*fiadr).mode = generation ;     /* [h                 */
     (*fiadr).textfile = true   ;     /* eLXgt@C           */
     (*fiadr).writelnflag = true;     /* rewriteɂ͉sȂ*/
}

/***************************************/
/* WLN() : writelnW葱           */
/***************************************/
static void WLN(void)
{
  fileinfo *fiadr ;

     fiadr = searchfile((*sp--).va) ;
     checkgeneration("writeln",fiadr) ;
     if(fputc('\n',(*fiadr).fp) == EOF) err131("writeln",fiadr) ;
     (*fiadr).writelnflag = true ;
}

/***************************************/
/* WRB() : boolean^̏o             */
/***************************************/
static void WRB(void)
{
  fileinfo *fiadr ;
  char *put ;
  short i,j,k ;
  FILE *fp  ;

     fiadr = searchfile((*sp).va) ;
     fp = (*fiadr).fp ;

     checkgeneration("write",fiadr) ;

     put = ((*(sp-2)).vb) ?  "TRUE" : "FALSE" ;
     j   = strlen(put) ;                /* o͕                 */
     k = (short)(*(sp-1)).vi ;          /* o͕                     */

     if(k>j)                            /* 󔒂Kv̂鎞   */
      for(i=1;i<=(k-j);i++)
       if(fputc(' ',fp) == EOF) err131("write",fiadr) ;
     else j= k ;
     for(i=0;i<j;i++)
      if(fputc((int)put[i], fp) == EOF) err131("write",fiadr) ;

     (*fiadr).writelnflag = false ;

     sp-=3;
}

/***************************************/
/* WRC() : eLXgt@Cɕo  */
/***************************************/
static void WRC(void)
{
  fileinfo *fiadr ;
  int i ;
  FILE *fp  ;

     fiadr = searchfile((*sp).va) ;
     fp = (*fiadr).fp ;

     checkgeneration("write",fiadr) ;

     for(i=1;i<(int)(*(sp-1)).vi;i++)
      if(fputc(' ',fp) == EOF) err131("write",fiadr) ;
     if(fputc((*(sp-2)).vc,fp) == EOF) err131("write",fiadr) ;

     (*fiadr).writelnflag = false ;

     sp-=3 ;
}

/***************************************/
/* WRF() : eLXgt@CɎo  */
/***************************************/
static void WRF(void)
{
  fileinfo *fiadr ;
  FILE *fp  ;
  char buf1[80] ;
  char buf2[80] ;
  int width ;
  int i ;

     fiadr = searchfile((*sp).va) ;
     fp = (*fiadr).fp ;

     checkgeneration("write",fiadr) ;

     *buf1 = '%' ;                      /*  %1.xfƂ`𐶐       */
     sprintf(buf1+1,"1.%df",(int)(*(sp-1)).vi) ;   /* _ȉ̌*/
     width = sprintf(buf2,buf1,(*(sp-3)).vr);      /* Œ菬_ϊ  */
     for(i=width;i<(int)(*(sp-2)).vi;i++)
      if(fputc(' ',fp) == EOF)          /* Oɋ󔒂o͂         */
       err131("write",fiadr) ;
     if(fputs(buf2,fp) != 0) err131("write",fiadr) ;

     (*fiadr).writelnflag = false ;

     sp-=4 ;
}

/***************************************/
/* WRI() : eLXgt@Cɐo  */
/***************************************/
static void WRI(void)
{
  char buf[12];
  fileinfo *fiadr ;
  FILE *fp  ;
  short i,len ;

     fiadr = searchfile((*sp).va) ;
     fp = (*fiadr).fp ;

     checkgeneration("write",fiadr) ;

      len=sprintf(buf,"%ld",(*(sp-2)).vi); /* o͂ɕKvȌ      */
      for(i=(short)(*(sp-1)).vi;i>len;i--)
       if(fputc(' ',fp) == EOF)         /* ̑Oɋ󔒂o͂   */
        err131("write",fiadr) ;
      if(fputs(buf,fp) != 0) err131("write",fiadr) ;

     (*fiadr).writelnflag = false ;

     sp -= 3 ;
}

/***************************************/
/* WRR() : eLXgt@CɎo  */
/***************************************/
static void WRR(void)
{
  char buf[15] ;
  int keta     ;
  int width    ;
  int point    ;
  fileinfo *fiadr ;
  FILE *fp  ;

     fiadr = searchfile((*sp).va) ;
     fp = (*fiadr).fp ;

     checkgeneration("write",fiadr) ;

     keta  = (int)(*(sp-1)).vi    ;     /* o͌                     */
     width = (keta >= 9) ? keta : 9 ;   /* Kvo͌                 */
     point = width - 8 ;
     *buf = '%' ;                       /* %x.xĚ`ɕϊ            */
     sprintf(buf+1,"%d.%dE",width,point);
     fprintf(fp,buf,(*(sp-2)).vr) ;

     (*fiadr).writelnflag = false ;

     sp -= 3 ;
}

/***************************************/
/* WRS() : eLXgt@Cɕo*/
/***************************************/
static void WRS(void)
{
  fileinfo *fiadr ;
  FILE *fp  ;
  short i,j,k ;
  int ad    ;

     fiadr = searchfile((*sp).va) ;
     fp = (*fiadr).fp ;

     checkgeneration("write",fiadr) ;

     ad=        (*(sp-3)).va ;
     k = (short)(*(sp-2)).vi ;          /* k=o͕                   */
     j = (short)(*(sp-1)).vi ;          /* j=                   */

     if(k>j)                            /* 󔒂Kv̂鎞   */
      for(i=1;i<=(k-j);i++)
       if(fputc(' ',fp) == EOF) err131("write",fiadr) ;
     else j= k ;
     for(i=0;i<j;i++)
      if(fputc(store[ad+i].vc,fp) == EOF) err131("write",fiadr) ;

     (*fiadr).writelnflag = false ;

     sp-=4;
}


/**********************************************************************/
/*                      P-code    Gg\                    */
/**********************************************************************/

static struct entry {
       void (*func)(void) ;
} pcd[] = {
           /*         xx0  xx1  xx2  xx3  xx4  xx5  xx6  xx7  xx8  xx9   */

           /*00x*/    GET, PUT, RST, RLN, NEW, WLN, WRS, WRB, WRI, WRR,
           /*01x*/    WRC, RDI, RDR, RDC, SIN, COS, EXP, LOG, SQT, ATN,
           /*02x*/    PGE, EoF, EOL, DIS, WRF, RWT, TRS, TRW, TGT, TPT
         };

/********* callsp() : csp ߂̎s ***********/
void callsp(void)
{
     pcd[q].func() ;                    /* opɑΉ߂s     */
}
